/*************************************************************************************************
*
*
*			MacZoop - "the framework for the rest of us"		 
*
*
*
*			ZGIFFile.h			-- a file object that can open GIF images
*
*
*
*
*
*			 1996, Graham Cox
*
*
*
*
*************************************************************************************************/



#pragma once

#ifndef __ZGIFFILE__
#define	__ZGIFFILE__

#include	"ZFile.h"
#include	<QDOffscreen.h>

class	ZGWorld;



class	ZGIFFile : public ZFile
{
public:

	ZGIFFile( const FSSpec& aSpec );

	virtual void	Read( ZGWorld*   aGWorld );
	virtual void	Read( GWorldPtr* aGWorld );
};


// this is a file class that can read GIF (GIFf) image files. The Read() methods
// above will either (a) modfy the GWorld of a ZGWorld object to suit the image. This is the
// recommended method, or (b) return a "naked" GWorld appropriately built.

#define	strCantOpenData			980		/* Constants for gMessage */
#define	strGIFNoMem				981		
#define	strCantRead				982		
#define	strInvalidGIFSig		983		
#define	strCantSetFPos			984
#define	strUnknownGIFBlock		985
#define	strNoColorMap			986

#endif