/***********************************************************************************************
*
*		Name:  				PatternMenu.h
*		Description:		A MDEF for displaying patterns, B & W or colour.
*
*		Date Created:		December 20th, 1995
*		Author:				Graham Cox
*		
*		Revision History:	
*
*
*
*		Notes:
*	
*
***********************************************************************************************/

#pragma once

#ifndef	__PATTERNMENUMDEF__
#define __PATTERNMENUMDEF__

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=mac68k
#endif

// resource structure for colour pattern lists

typedef struct
{
	short	numPatterns;
	short	patID[1];
}
CPatList, *CPatListPtr, **CPatListHdl;


#define		kCPatListResType	'PPT#'


// the menu handle record is altered thus:

typedef struct
{
	MenuInfo		menuRecord;
	short			patListType;
	short			patListID;
	CPatListHdl		patListHdl;
	long			menuRefCon;
	short			initIndex;
	RGBColor		patFore;
	RGBColor		patBack;
}
CPatMenuRecord, *CPatMenuPtr, **CPatMenuHandle;

// pat list type codes:

enum
{
	patListSysList,
	patListBW,
	patListColour,
	patListBWColourised
};

#ifdef __cplusplus
extern "C"
#endif

// prototype for MDEF

pascal void	CPatMDEFFunction(short message,MenuHandle theMenu,
								Rect *menuRect,Point hitPt,short *whichItem);
								
// user API to make life just one big bowl of cherries...

long	PopUpCPatternMenu(Point globalLoc,short patListID,short initialItem);
long	PopUpBWPatternMenu(Point globalLoc,short patListID,short initialItem);
long	PopUpBWColourisedMenu(Point globalLoc,short patListID,short initialItem,RGBColor* fClr,RGBColor* bClr);

// note that these routines create and destroy the menu on the fly and cope with the
// menu manager inadequacies for you- thus you cannot pass a specific menu nor do you
// ever need to. Simply create the pattern list resources and away you go!

PixPatHandle	GetIndCPattern(short patListID, short index);

// private internal utilities- but you can use them if you want.

CPatListHdl		GetCPatternList(short patListID);

#ifdef __cplusplus
}
#endif


#define		kPatternMenuID	1067

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=reset
#endif


#endif