/*************************************************************************************************
*
*
*			MacZoop - "the framework for the rest of us"		 
*
*
*
*			ZFileStream.h		-- a stream using file storage
*
*
*
*
*
*			 1998, Graham Cox
*
*
*
*
*************************************************************************************************/


#pragma once

#ifndef __ZFILESTREAM__
#define	__ZFILESTREAM__

#include	"ZStream.h"
#include	"ZFile.h"


enum
{
	CLASS_ZFileStream		= 'zfst'
};


class	ZFileStream	: public ZFile, public ZStream
{
public:

	ZFileStream( const FSSpec& aFileSpec );
	ZFileStream( Str255 fName );
	ZFileStream();
	
	virtual 	~ZFileStream();
	
	virtual void	Reset();
	virtual void	Skip( long bytesToSkip );

protected:
	virtual void	PutTo( void* data, long dataLen );
	virtual void	GetFrom( void* data, long* dataLen );
	
	void			InitFileStream();
	
	Boolean			dataWasWritten;	
};



#endif
