/*************************************************************************************************
*
*
*			MacZoop - "the framework for the rest of us"		 
*
*
*
*			ZInspectorWindow.cpp		-- inspector window object
*
*
*
*
*
*			 1998, Graham Cox
*
*
*
*
*************************************************************************************************/

#include	"ZInspectorWindow.h"
#include	"MacZoop.h"


void	ZInspectorWindow::InitZWindow()
{
	ZWindow::InitZWindow();
	ListenTo( gWindowManager );
}


void	ZInspectorWindow::ReceiveMessage( ZComrade* aSender, long aMsg, void* msgData )
{
	if ( aSender == gWindowManager )
	{
		switch ( aMsg )
		{
			case kWMMsgWindowAdded:
				if ( AcceptWindow((ZWindow*) msgData ))
					WindowCreated((ZWindow*) msgData );
				break;
	
			case kWMMsgWindowRemoved:
				if ( AcceptWindow((ZWindow*) msgData ))
					WindowDestroyed((ZWindow*) msgData );
				break;
	
			case kWMMsgWindowActivated:
				if ( AcceptWindow((ZWindow*) msgData ))
					WindowBecomeActive((ZWindow*) msgData );
				break;
	
			case kWMMsgWindowDeactivated:
				if ( AcceptWindow((ZWindow*) msgData ))
					WindowBecomeInactive((ZWindow*) msgData );
				break;
	
			case kWMMsgWindowHidden:
				if ( AcceptWindow((ZWindow*) msgData ))
					WindowBecomeHidden((ZWindow*) msgData );
				break;
	
			case kWMMsgWindowShown:
				if ( AcceptWindow((ZWindow*) msgData ))
					WindowBecomeVisible((ZWindow*) msgData );
				break;
		}
	}
}
