/*************************************************************************************************
*
*
*			MacZoop - "the framework for the rest of us"		 
*
*
*
*			ZPictWindow.h		-- a window that displays PICT files
*
*
*
*
*
*			 1996, Graham Cox
*
*
*
*
*************************************************************************************************/


#pragma once

#ifndef __ZPICTWINDOW__
#define __ZPICTWINDOW__

#ifndef __ZSCROLLER__
#include	"ZScroller.h"
#endif


// set up streaming stuff:

DEFINECLASSID( ZPictWindow, 'zpcw' );

// class def:

class	ZPictWindow : public ZScroller
{
protected:
	Boolean		savePreview;
	Boolean		saveCustomIcon;
	PicHandle	thePicture;
	
public:

	ZPictWindow( ZCommander* aBoss, const short windID );
	ZPictWindow();
	virtual ~ZPictWindow();
	
	virtual void	DrawContent();
	virtual void	OpenFile( const OSType fType, Boolean isStationery = FALSE );
	virtual void	SaveFile();
	virtual void	UpdateMenus();
	
	virtual Boolean	CanPasteType();
	virtual void	DoCopy();
	virtual void	DoPaste();
	
	virtual void	SetPictureFromResource( short pictResID );
	
	inline	void	SetSavePreview( Boolean saveIt ) { savePreview = saveIt; };
	inline	void	SetSaveCustomIcons( Boolean saveIt ) { saveCustomIcon = saveIt; };

// streaming
	virtual void	WriteToStream( ZStream* aStream );
	virtual void	ReadFromStream( ZStream* aStream );
};




#endif