/*************************************************************************************************
*
*
*			ObjectMacZapp			-- a standard Mac OOP application template
*
*
*
*			ZShowOffApplication.h	-- the application object
*
*
*
*
*
*			 1996, Graham Cox
*
*
*
*
*************************************************************************************************/


#pragma once

#ifndef __ZSHOWOFFAPPLICATION__
#define	__ZSHOWOFFAPPLICATION__

#include	"ZApplication.h"



class	ZShowOffApplication : public ZApplication
{
protected:
	OSType	anFType;
	
public:
	ZShowOffApplication();

	virtual void	MakeNewWindow();
	virtual void	UpdateMenus();
	virtual void	HandleCommand( const long aCmd );
	virtual void	OpenFile( const FSSpec& aFile, const OSType fType, Boolean isStationery = FALSE );

	virtual void	StartUp();
	virtual void	ShutDown();

	virtual void	OpenDialog(short id);
	virtual void	NewFloater();
	
	virtual void	TestProgress();
	virtual void	TestScan();
	virtual void	DoPreferences();
	virtual ZWindow*	MakeNewWindowType( OSType aType = 0 );
	virtual void	TestNotification();
	virtual void	OpenInspector();
	
	virtual void	ReceiveMessage( ZComrade* aSender, long aMsg, void* msgData );
};


#define		kTestMenu		131

#define		kDialog1		140
#define		kDialog2		141
#define		kDialog3		142

#define		kFloaterID		130

// some items in the moveable modal dialog that the app handles (to demo this feature)

#define		kEnableOKButtonCheckBox		5
#define		kEnableGroupCheckBox		10
#define		kEnableFieldCheckBox		15
#define		kDisableFieldCheckBox		16
#define		kEditField					4

// commands we define:

enum
{
	kCmdOpenMoveableModal = 420,
	kCmdOpenModal,
	kCmdOpenModeless,
	kCmdTestProgress,
	kCmdScanFolder = 194,
	kCmdNewFloater = 443,
	kCmdOpenTextWindow,
	kCmdOpenGWorldWindow,
	kCmdOpenPlainWindow,
	kCmdOpenScrollerWindow,
	kCmdOpenHexEditorWindow,
	kCmdOpenSortTestWindow,
	kCmdOpenListWindow,
	kCmdTestNotification,
	kCmdTestStacks,
	kCmdShowInspector = 555
};


#endif