/*************************************************************************************************
*
*
*			ObjectMacZapp		-- a standard Mac OOP application template
*
*
*
*			ZSortTestWindow.h			-- a window for testing the sort function
*
*
*
*
*
*			 1996, Graham Cox
*
*
*
*
*************************************************************************************************/


#pragma once

#ifndef __ZSORTTESTWINDOW__
#define	__ZSORTTESTWINDOW__


#include	"ZScroller.h"



class	ZArray;
class	ZStream;

// set up streaming stuff:

DEFINECLASSID( ZSortTestWindow, 'STSW' );

// class def:


class	ZSortTestWindow : public ZScroller
{
protected:
	ZArray*		itsArray;
	long		sortTime;

public:
	ZSortTestWindow( ZCommander* aBoss, short windID );
	ZSortTestWindow();
	~ZSortTestWindow();
	
	virtual void	InitZWindow();
	virtual void	DrawContent();
	virtual void	OpenFile( const OSType aType, Boolean isStationery = FALSE );
	
	virtual void	UpdateMenus();
	virtual void	HandleCommand( const long aCmd );
	
	virtual void	WriteToStream( ZStream* aStream );
	virtual void	ReadFromStream( ZStream* aStream );
	
protected:
	void			CalcBounds();
};

// commands we define:

enum
{
	kCmdSort = 195,
	kCmdScramble
};



#endif