/*************************************************************************************************
*
*
*			MacZoop - "the framework for the rest of us"		 
*
*
*
*			Compatibility.h			-- allow old universal headers to be used with new code
*
*
*
*
*
*			 1996, Graham Cox
*
*
*
*
*************************************************************************************************/


#pragma once

#ifndef	__COMPATIBILITY__
#define __COMPATIBILITY__

/*

MacZoop 1.8.2 and later requires at least version 3.0.1 of Universal Headers to compile.
However, to keep older compiler/header combinations in the frame, this file will be
included which maps the newer names to the older ones, so no-one has to worry about that.


*/

// font constants:

enum {
	kFontIDNewYork 		= newYork,
	kFontIDGeneva 		= geneva,
	kFontIDMonaco 		= monaco,
	kFontIDVenice 		= venice,
	kFontIDLondon 		= london,
	kFontIDAthens 		= athens,
	kFontIDSanFrancisco = sanFran,
	kFontIDToronto 		= toronto,
	kFontIDCairo 		= cairo,
	kFontIDLosAngeles 	= losAngeles,
	kFontIDTimes 		= times,
	kFontIDHelvetica 	= helvetica,
	kFontIDCourier 		= courier,
	kFontIDSymbol 		= symbol,
	kFontIDMobile 		= mobile
};

// drag manager constants:

enum {
	kDragTrackingEnterHandler	= 1,							/* drag has entered handler*/
	kDragTrackingEnterWindow	= 2,							/* drag has entered window*/
	kDragTrackingInWindow		= 3,							/* drag is moving within window*/
	kDragTrackingLeaveWindow	= 4,							/* drag has exited window*/
	kDragTrackingLeaveHandler	= 5								/* drag has exited handler*/
};

// window zooming:

enum {
	kZoomNoAcceleration			= 0,							/* use linear interpolation*/
	kZoomAccelerate				= 1,							/* ramp up step size*/
	kZoomDecelerate				= 2								/* ramp down step size*/
};



#endif
